#!/usr/bin/perl -w 

###############################################################################
#                                                                             #
# articlesDB_2_MPIformat.perl - formatiert die ausgelesene daten von          #
#                   typischen mysql format in IBIS spezifischen um.           #
#                                                                             #
###############################################################################
# Ablauf:                                                                     #
#          der file muss in mysql format vorliegen.                           #
#          Eingabe file muss eine bestimmte name haben. Siehe unten.          #
#          Ausgabe file hat auch einen namen. Siehe unten.                    #
#          Es wird ein file genommen, und der endfile erzeugt.                #
#          Details kann man von den einzelnschritten herausnehmen.            #
#                                                                             #
###############################################################################

# ----------------------
# Letzte Aenderung 9.9.01:
# ----------------------
# Habe die absoluten pfade dazugefuegt, weil sonst findet dieser script die 
# dateien nicht, wenn er nicht gerade von richtigen direktorie gestartet wird.
#
#

#---------------------
# Letzte Aenderung 5.2.01 :
#---------------------
# Vertig
#
# Dieser script wandelt die mysql daten von artikeln -> mpi format.
#
#
#
#

#------------------------------------------------------------------------------
# --> 0.1 <--   hier wird space vor jeder zeile eingefuegt
#  
#             
#------------------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/articles_db.txt")
  || die "cannot open file for reading: $!";
open (write_in,">/home/SG/dainius/fopra/db-2-mpi/o")
  || die "cannot open file for writing: $!";


@leer = ("% ");



while (<read_out>)
  {
    @zeile = $_;
    @zeile = (@leer,@zeile);

    
print write_in "@zeile"; 
  }
#------------------------------------------------------------------------------
# --> 1. <--   hier werden statt "\t" die "%" zeichen eingefuegt
#  
#             
#------------------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/o")
  || die "cannot open file for reading: $!";
open (write_in,">/home/SG/dainius/fopra/db-2-mpi/a")
  || die "cannot open file for writing: $!";
#@komma=(",");

while (<read_out>)
  {
   # $eingabe = $_;

    s/\t/%/g; # alle      \t  -> %
  #  s/\s/%/;  # der erste \s  -> %
    

    
print write_in "$_"; 
  }
#---------------------------------------------------------------------
# --> 2 <-- Ersetze verschieden sachen weiter, die reihenfolge ist wichtig !
#-------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/a")
  || die "cannot open file for reading: $!";
open (write_in,">/home/SG/dainius/fopra/db-2-mpi/b")
  || die "cannot open file for writing: $!";
#@komma=(",");

while (<read_out>)
  {
   # $eingabe = $_;

    s/%/\n% /g;  # ersetze  % -> "\n% "
    #s/% 1\n/% Verf\\\"ugbar/g;
    #s/% 1\n/% Verf\\\"ugbar/g;

    #s/200*-..-../Ausgeliehen/g;


    #s/\s/%/;
    
print write_in "$_"; 
  }

#---------------------------------------------------------------------
# --> 3 <-- Fuege die Buchstaben nach der Reihenfolge ein!
#-------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/b")
  || die "cannot open file for reading: $!";
open (write_in,">/home/SG/dainius/fopra/db-2-mpi/c")
  || die "cannot open file for writing: $!";

@Reihe = qw(A E T J X D K P Z W);





$i = 0;
while (<read_out>)
  {
    
    if ( chomp($_) eq /%/) # geht bis zu der ersten leeren zeile 
      {

	s/%/%$Reihe[$i]/;
	$i++;

      }
    else 
      {
	$i = 0;
      }
    
    print write_in "$_\n"; 
  }

#---------------------------------------------------------------------
# --> 4 <-- Ersetze die ";" durch "\n" und "%A"
#-------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/c")
  || die "cannot open file for reading: $!";
open (write_in,">/home/SG/dainius/fopra/db-2-mpi/d")
  || die "cannot open file for writing: $!";

while (<read_out>)
  { 
    if ( chomp($_) eq /%A/ && /;/ )
      {
	s/;/\n%A /g;
      }
    
    print write_in "$_\n";
    
  }
#---------------------------------------------------------------------
# --> 5 <-- Ersetze die ";" durch "\n" und "%E"
#-------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/d")
  || die "cannot open file for reading: $!";
open (write_in,">/home/SG/dainius/fopra/db-2-mpi/e")
  || die "cannot open file for writing: $!";

while (<read_out>)
  { 
    if ( chomp($_) eq /%E/ && /;/ )
      {
	s/;/\n%E /g;
      }
    
    print write_in "$_\n";
    
  }

#---------------------------------------------------------------------
# --> 6 <-- (i)   Fuege den leerzeichen zwischen Namen und Vornamen.
#           (ii) Mache alle doppelten spaces weg.
#-------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/e")
  || die "cannot open file for reading: $!";

open (write_in,">/home/SG/dainius/fopra/db-2-mpi/f")
  || die "cannot open file for reading: $!";


while (<read_out>)
  { 

    	s/,/, /g;
	s/\s+/ /g;    

    print write_in "$_\n";
    
  }



#------------------------------------------------------------------------------
# --> 7 <-- (i)   Mache alle leeren zeilen weg
#           (ii)  MAche alle leeren zeilen weg, die am anfang leere zeile haben
#-----------------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/f")
  || die "cannot open file for reading: $!";

open (write_in,">/home/SG/dainius/fopra/db-2-mpi/g")
    || die "cannot open file for writing: $!";


while (<read_out>)
{ 
      
	s/%\w\s\n//; # (i)
      	s/^ //; # (ii)

    print write_in "$_";
  
}

#---------------------------------------------------------------------
# --> 8 <-- Konvertiere alle umlaute in \"a 
#-------------------------------------------------------------------

open (read_out,"/home/SG/dainius/fopra/db-2-mpi/g")
  || die "cannot open file for reading: $!";

open (write_in,">/home/SG/dainius/fopra/db-2-mpi/articles.kat")
  || die "cannot open file for writing: $!";


while (<read_out>)
{ 
      
    s//\\\"a/g;
    s//\\\"A/g;

    s//\\\"o/g;
    s//\\\"O/g;

    s//\\\"u/g;
    s//\\\"U/g;

    s//\\\"s/g;  
         
    print write_in "$_";
  
}

unlink qw(/home/SG/dainius/fopra/db-2-mpi/a /home/SG/dainius/fopra/db-2-mpi/b /home/SG/dainius/fopra/db-2-mpi/c /home/SG/dainius/fopra/db-2-mpi/d /home/SG/dainius/fopra/db-2-mpi/e /home/SG/dainius/fopra/db-2-mpi/f /home/SG/dainius/fopra/db-2-mpi/g /home/SG/dainius/fopra/db-2-mpi/o );
